#version 330
#extension GL_ARB_separate_shader_objects : enable





layout(location = 0) smooth in vec4 _fin_fragWorldPosition;

struct SFragmentInput
{
	vec4 fragWorldPosition;
	bool IsFrontFace;
};

layout(location = 0) out vec2 _fout_outDepth;

struct SFragmentOutput
{
	vec2 outDepth;
};

layout( std140) uniform USceneInfo
{
	mat4 ViewProj;
	mat4 View;
	mat4 Proj;
	mat4 InvView;
	mat4 InvViewProj;
	mat4 UserToLHZ;
	mat4 LHZToUser;
	mat4 BillboardingView;
	mat4 PackNormalView;
	mat4 UnpackNormalView;
	vec4 SideVector;
	vec4 DepthVector;
	vec2 ZBufferLimits;
	vec2 ViewportSize;
	float Handedness;
} SceneInfo;




void FragmentMain( in SFragmentInput  fInput,  out SFragmentOutput  fOutput  )
{
	float shadowDepth = fInput.fragWorldPosition.z / fInput.fragWorldPosition.w;
	fOutput.outDepth = vec2(shadowDepth, shadowDepth * shadowDepth);
}


void main()
{
	SFragmentInput fInput;
	SFragmentOutput fOutput;

	fInput.fragWorldPosition = _fin_fragWorldPosition;
	fInput.IsFrontFace = gl_FrontFacing;
	FragmentMain(fInput, fOutput);
	_fout_outDepth = fOutput.outDepth;
}
