#version 430
#extension GL_ARB_separate_shader_objects : enable










struct SComputeInput
{
	uvec3 GlobalThreadID; uvec3 LocalThreadID; uvec3 GroupID;};

layout(std430 ) readonly buffer BInIndirection
{
	uint InIndirection[];
} InIndirection;
layout(std430 ) readonly buffer BInKeys
{
	uint InKeys[];
} InKeys;
layout(std430 ) buffer BOutCounts
{
	uint OutCounts[];
} OutCounts;

layout( std140) uniform UInfo
{
	uint CurrentBit;
} Info;

shared uvec4 localCounts[576];





void ComputeMain( in SComputeInput  cInput  )
{
	const uint globalThreadID = cInput.GlobalThreadID.x;
	const uint localThreadID = cInput.LocalThreadID.x;
	const uint groupID = cInput.GroupID.x;

	const uint currentBit =  Info.CurrentBit  * 4;
	const uint blocki = groupID *  128  *  24  + localThreadID;

	{
		uint ai = localThreadID * 4;


		for (uint k = 0; k < 4; ++k)
		{
			localCounts [ ((ai + k) + ((ai + k) >> 3)) ] = uvec4(0, 0, 0, 0);
		}
	}

	groupMemoryBarrier(); barrier(); ;

	const uvec4 add1v4[4] = { uvec4(1, 0, 0, 0), uvec4(0, 1, 0, 0), uvec4(0, 0, 1, 0), uvec4(0, 0, 0, 1) };

	for (uint item = 0; item <  24 ; ++item)
	{

		const uvec2 fullKey64 =  uvec2( InKeys.InKeys [ ((blocki + item * 128 ) * 2) ], InKeys.InKeys [( ((blocki + item * 128 ) * 2) ) + 1]) ;
		uint keyBits = ((currentBit < 32 ? fullKey64.y : fullKey64.x) >> (currentBit % 32)) & 15;
		const uint rowOffset = keyBits / 4;
		const uint subCounter = keyBits & (4 - 1);
		localCounts [ ((localThreadID * 4 + rowOffset) + ((localThreadID * 4 + rowOffset) >> 3)) ] += add1v4[subCounter];
	}

	groupMemoryBarrier(); barrier(); ;
	{

		uint ai = localThreadID * 2;
		uint bi = localThreadID * 2 +  128  * 2;

		localCounts [ ((ai) + ((ai) >> 3)) ] +=  localCounts [ ((bi) + ((bi) >> 3)) ];
		localCounts [ ((ai + 1) + ((ai + 1) >> 3)) ] +=  localCounts [ ((bi + 1) + ((bi + 1) >> 3)) ];
	}
	for (uint d =  128  / 4; d > 0; d /= 2)
	{
		groupMemoryBarrier(); barrier(); ;
		if (localThreadID < d * 4)
		{
			uint ai = localThreadID;
			uint bi = localThreadID + d * 4;

			localCounts [ ((ai) + ((ai) >> 3)) ] +=  localCounts [ ((bi) + ((bi) >> 3)) ];
		}
	}
	groupMemoryBarrier(); barrier(); ;

	if (localThreadID < 4)
	{
		OutCounts.OutCounts [ ((groupID * 4 + localThreadID) * 4) ] = ( localCounts [ ((localThreadID) + ((localThreadID) >> 3)) ]).x; OutCounts.OutCounts [( ((groupID * 4 + localThreadID) * 4) ) + 1] = ( localCounts [ ((localThreadID) + ((localThreadID) >> 3)) ]).y; OutCounts.OutCounts [( ((groupID * 4 + localThreadID) * 4) ) + 2] = ( localCounts [ ((localThreadID) + ((localThreadID) >> 3)) ]).z; OutCounts.OutCounts [( ((groupID * 4 + localThreadID) * 4) ) + 3] = ( localCounts [ ((localThreadID) + ((localThreadID) >> 3)) ]).w; ;
	}
}

layout(local_size_x = 128, local_size_y = 1, local_size_z = 1) in;
void main()
{
	SComputeInput cInput;
	cInput.GlobalThreadID = gl_GlobalInvocationID;
	cInput.LocalThreadID = gl_LocalInvocationID;
	cInput.GroupID = gl_WorkGroupID;
	ComputeMain(cInput);
}
